using System;
using System.Collections;

namespace SicamCore {
   /// <summary>
   /// Summary description for IdGenerator.
   /// </summary>
   public class IdGenerator {
      public const int IDLENGTH = 7;
      
      public IdGenerator() {
      }

      public static String createId() {
         String id = "";
         int seed = (int) DateTime.Now.Ticks;
         Random rand = new Random(seed);

         if( seed != _previousSeed ) {
            _recentIds = new ArrayList();
            _previousSeed = seed;
         }

         while(true) {
            id = "";
            for(int i = 0; i < (IDLENGTH - 1); i++) {
               id += _digits[rand.Next(_digits.Length)];
               if( i == 2 ) {
                  id += "-";
               }
            }

            if( ! _recentIds.Contains(id) ) {
               _recentIds.Add(id);
               return id;
            }
         }
      }

      private static int _previousSeed = 0;
      private static ArrayList _recentIds = new ArrayList();
      private const String _digits = "23456789ABCDEFGHJKLMNPQRSTUVWXYZ"; // 1, I, 0 and O left out on purpose [ml]
   }
}
