using System;

namespace SicamCore {
   public class Call : System.ComponentModel.Component {
      /// <summary>
      /// Required designer variable.
      /// </summary>
      private System.ComponentModel.Container components = null;

      public Call(System.ComponentModel.IContainer container) {
         /// <summary>
         /// Required for Windows.Forms Class Composition Designer support
         /// </summary>
         container.Add(this);
         InitializeComponent();

         //
         // TODO: Add any constructor code after InitializeComponent call
         //
      }

      private Call() {
         InitializeComponent();
      }

      public Call(string description) {
         /// <summary>
         /// Required for Windows.Forms Class Composition Designer support
         /// </summary>
         InitializeComponent();

         //
         // TODO: Add any constructor code after InitializeComponent call
         //
         _description = description;
      }

      public static Call Retrieve(string ID) {
         Call c = new Call();

         c.sqlSelectCommand1.CommandText += " WHERE ID='" + ID.Trim() + "'";
         c.sqlDataAdapter1.Fill(c.dsCall1);

         dsCall.CallRow row = (dsCall.CallRow) c.dsCall1.Tables[0].Rows[0];

         c._id = row.ID.Trim();
         c._description = row.Description;

         return c;
      }

      public string Description {
         get {
            return _description;
         }
      }

      public string Save() {
         dsCall.CallRow row = null;

         if(_id == null) {
            row = dsCall1.Call.NewCallRow();

            _id = IdGenerator.createId();
            row["ID"] = _id;

            dsCall1.Tables[0].Rows.Add(row);
         }
         else {
            dsCall1.Clear();
            row = (dsCall.CallRow) dsCall1.Tables[0].Select("ID='" + _id + "'")[0];
         }

         // Save members
         row.Description = _description;

         sqlDataAdapter1.Update(dsCall1);

         return _id;
      }

      private System.Data.SqlClient.SqlConnection sqlConnection1;
      private System.Data.SqlClient.SqlDataAdapter sqlDataAdapter1;
      private System.Data.SqlClient.SqlCommand sqlSelectCommand1;
      private System.Data.SqlClient.SqlCommand sqlInsertCommand1;
      private System.Data.SqlClient.SqlCommand sqlUpdateCommand1;
      private System.Data.SqlClient.SqlCommand sqlDeleteCommand1;
      private SicamCore.dsCall dsCall1;

      private string _description = string.Empty;
      private string _id = null;

      #region Component Designer generated code
      /// <summary>
      /// Required method for Designer support - do not modify
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent() {
         this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
         this.sqlDataAdapter1 = new System.Data.SqlClient.SqlDataAdapter();
         this.sqlSelectCommand1 = new System.Data.SqlClient.SqlCommand();
         this.sqlInsertCommand1 = new System.Data.SqlClient.SqlCommand();
         this.sqlUpdateCommand1 = new System.Data.SqlClient.SqlCommand();
         this.sqlDeleteCommand1 = new System.Data.SqlClient.SqlCommand();
         this.dsCall1 = new SicamCore.dsCall();
         ((System.ComponentModel.ISupportInitialize)(this.dsCall1)).BeginInit();
         // 
         // sqlConnection1
         // 
         this.sqlConnection1.ConnectionString = "data source=BLNPC01;initial catalog=_Sicam;integrated security=SSPI;persist secur" +
            "ity info=True;workstation id=BLNPC01;packet size=4096";
         // 
         // sqlDataAdapter1
         // 
         this.sqlDataAdapter1.DeleteCommand = this.sqlDeleteCommand1;
         this.sqlDataAdapter1.InsertCommand = this.sqlInsertCommand1;
         this.sqlDataAdapter1.SelectCommand = this.sqlSelectCommand1;
         this.sqlDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
                                                                                                  new System.Data.Common.DataTableMapping("Table", "Call", new System.Data.Common.DataColumnMapping[] {
                                                                                                                                                                                                         new System.Data.Common.DataColumnMapping("ID", "ID"),
                                                                                                                                                                                                         new System.Data.Common.DataColumnMapping("Description", "Description")})});
         this.sqlDataAdapter1.UpdateCommand = this.sqlUpdateCommand1;
         // 
         // sqlSelectCommand1
         // 
         this.sqlSelectCommand1.CommandText = "SELECT ID, Description FROM Call";
         this.sqlSelectCommand1.Connection = this.sqlConnection1;
         // 
         // sqlInsertCommand1
         // 
         this.sqlInsertCommand1.CommandText = "INSERT INTO Call(ID, Description) VALUES (@ID, @Description); SELECT ID, Descript" +
            "ion FROM Call WHERE (ID = @ID)";
         this.sqlInsertCommand1.Connection = this.sqlConnection1;
         this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ID", System.Data.SqlDbType.VarChar, 10, "ID"));
         this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Description", System.Data.SqlDbType.VarChar, 50, "Description"));
         // 
         // sqlUpdateCommand1
         // 
         this.sqlUpdateCommand1.CommandText = "UPDATE Call SET ID = @ID, Description = @Description WHERE (ID = @Original_ID) AN" +
            "D (Description = @Original_Description OR @Original_Description IS NULL AND Desc" +
            "ription IS NULL); SELECT ID, Description FROM Call WHERE (ID = @ID)";
         this.sqlUpdateCommand1.Connection = this.sqlConnection1;
         this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ID", System.Data.SqlDbType.VarChar, 10, "ID"));
         this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Description", System.Data.SqlDbType.VarChar, 50, "Description"));
         this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ID", System.Data.SqlDbType.VarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
         this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Description", System.Data.SqlDbType.VarChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Description", System.Data.DataRowVersion.Original, null));
         // 
         // sqlDeleteCommand1
         // 
         this.sqlDeleteCommand1.CommandText = "DELETE FROM Call WHERE (ID = @Original_ID) AND (Description = @Original_Descripti" +
            "on OR @Original_Description IS NULL AND Description IS NULL)";
         this.sqlDeleteCommand1.Connection = this.sqlConnection1;
         this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ID", System.Data.SqlDbType.VarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
         this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Description", System.Data.SqlDbType.VarChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Description", System.Data.DataRowVersion.Original, null));
         // 
         // dsCall1
         // 
         this.dsCall1.DataSetName = "dsCall";
         this.dsCall1.Locale = new System.Globalization.CultureInfo("de-DE");
         this.dsCall1.Namespace = "http://www.tempuri.org/dsCall.xsd";
         ((System.ComponentModel.ISupportInitialize)(this.dsCall1)).EndInit();

      }
		#endregion
   }
}
